; ##############################################################################
; ##############################################################################
; ##############################################################################

; DCF-PHASE_TIMERWERT							
.equ DCF_PHASE_TIMERWERT				= 3			; (2...20) nach einigen Sekunden Phase schieben				
; DCF-ERROR-CODES								
.equ ERROR_DCF_MINUTENSTART				= 0x01
.equ ERROR_DCF_MESZ						= 0x17
.equ ERROR_DCF_NO_ANFANGSBIT			= 0x20
.equ ERROR_DCF_MINUTE					= 0xAA
.equ ERROR_DCF_MINUTE_PARITAET			= 0xA1
.equ ERROR_DCF_STUNDE					= 0xBB
.equ ERROR_DCF_STUNDE_PARITAET			= 0xB1
.equ ERROR_DCF_TAG						= 0xCC
.equ ERROR_DCF_WOCHENTAG				= 0xDD
.equ ERROR_DCF_MONAT					= 0xEE
.equ ERROR_DCF_JAHR						= 0xFF
.equ ERROR_DCF_DATUM_PARITAET			= 0xF1
.equ ERROR_DCF_VERGLEICH				= 0x88
; SRAM-Belegung									
.equ adr_DCF_10ms						= adr_DCF_BEREICH+0			;
.equ adr_DCF_ss							= adr_DCF_BEREICH+1			; Sekunden 						
.equ adr_DCF_mm							= adr_DCF_BEREICH+2			; Minuten 	aus DCF-Protokoll	
.equ adr_DCF_mm_OLD						= adr_DCF_BEREICH+3
.equ adr_DCF_hh							= adr_DCF_BEREICH+4			; Stunden 	aus DCF-Protokoll	
.equ adr_DCF_hh_OLD						= adr_DCF_BEREICH+5
.equ adr_DCF_TAG						= adr_DCF_BEREICH+6			; Tag	 	aus DCF-Protokoll	
.equ adr_DCF_TAG_OLD					= adr_DCF_BEREICH+7
.equ adr_DCF_WOCHENTAG					= adr_DCF_BEREICH+8			; WochenTag aus DCF-Protokoll	
.equ adr_DCF_WOCHENTAG_OLD				= adr_DCF_BEREICH+9
.equ adr_DCF_MONAT						= adr_DCF_BEREICH+10		; Monat	 	aus DCF-Protokoll	
.equ adr_DCF_MONAT_OLD					= adr_DCF_BEREICH+11
.equ adr_DCF_JAHR						= adr_DCF_BEREICH+12		; Jahr	 	aus DCF-Protokoll	
.equ adr_DCF_JAHR_OLD					= adr_DCF_BEREICH+13
.equ adr_DCF_MESZ						= adr_DCF_BEREICH+14		; SOMMERZEIT aus DCF-Protokoll	
.equ adr_DCF_MESZ_OLD					= adr_DCF_BEREICH+15
.equ adr_DCF_GUELTIG					= adr_DCF_BEREICH+16		; DCF-Protokoll ist gltig		
.equ adr_DCF_TURBO_OFF					= adr_DCF_BEREICH+17
.equ adr_DCF_ERROR_CODE					= adr_DCF_BEREICH+18		; DCF-ERROR-CODE				
.equ adr_DCF_PIN_INVERTIERUNG			= adr_DCF_BEREICH+19		; >127 EINGANSPEGEL invertieren	
.equ adr_DCF_TRAEGER					= adr_DCF_BEREICH+20		; DCF-TRGER (1=EIN)			
.equ adr_DCF_TRAEGER_OLD				= adr_DCF_BEREICH+21		; DCF-TRGER (1=EIN)			
.equ adr_DCF_SAMPLES_A					= adr_DCF_BEREICH+22		; SAMPLES_A (100ms)				
.equ adr_DCF_PHASE						= adr_DCF_BEREICH+23		; PHASE							
.equ adr_DCF_PHASE_TIMER				= adr_DCF_BEREICH+24		; TIMER fr PHASE				
.equ adr_DCF_BYTE0						= adr_DCF_BEREICH+25		; DCF-DATA						
.equ adr_DCF_BYTE1						= adr_DCF_BEREICH+26		; DCF-DATA						
.equ adr_DCF_BYTE2						= adr_DCF_BEREICH+27		; DCF-DATA						
.equ adr_DCF_BYTE3						= adr_DCF_BEREICH+28		; DCF-DATA						
.equ adr_DCF_BYTE4						= adr_DCF_BEREICH+29		; DCF-DATA						
.equ adr_DCF_BYTE5						= adr_DCF_BEREICH+30		; DCF-DATA						
.equ adr_DCF_BYTE6						= adr_DCF_BEREICH+31		; DCF-DATA						
.equ adr_DCF_BYTE7						= adr_DCF_BEREICH+32		; DCF-DATA						
; ##############################################################################
; ##############################################################################
; ##############################################################################
; DCF-EINGANG																	
DCF_INITIALISIERUNG:
	cbi (DCF_DDR) ,(DCF_PIN_NR) ; auf EINGANG
	cbi (DCF_PORT),(DCF_PIN_NR) ; PULL UP aus, wichtig, denn manche DCF-Module sehr hochohmig !

	ldi temp,(255/2)
	STS(adr_DCF_PIN_INVERTIERUNG),temp

	ldi temp,(DCF_PHASE_TIMERWERT)
	STS(adr_DCF_PHASE_TIMER),temp

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Register: temp, temp1, temp2, temp3, ZL, ZH									
;																				
DCF:
	LDS temp,(adr_DCF_10ms)
	inc temp				; +1 	
	cpi temp,(100)
	brsh DCF_SS
	STS(adr_DCF_10ms),temp
	rjmp DCF_MM_FERTIG
DCF_SS:
	STS(adr_DCF_10ms),NULL	; NULL	
	LDS temp,(adr_DCF_ss)
	inc temp				; +1 	
	cpi temp,(59+1)
	brsh DCF_MM
	STS(adr_DCF_ss),temp
	rjmp DCF_MM_FERTIG
DCF_MM:
	STS(adr_DCF_ss),NULL	; NULL	
DCF_MM_FERTIG:
;-------------------------------------------------------------------------------
; Berechnung durchfhren und Uhr stellen ?										
	LDS  temp,(adr_DCF_ss)
	tst  temp					; =NULL ?		
	brne DCF_BERECHNUNG_FERTIG	; nein-->Sprung	
	LDS  temp,(adr_DCF_10ms)
	tst  temp					; =NULL ?		
	brne DCF_BERECHNUNG_FERTIG	; nein-->Sprung	
	; BERECHNUNG				
	rcall DCF_BERECHNUNG
	STS(adr_DCF_BYTE0),NULL
	STS(adr_DCF_BYTE1),NULL
	STS(adr_DCF_BYTE2),NULL
	STS(adr_DCF_BYTE3),NULL
	STS(adr_DCF_BYTE4),NULL
	STS(adr_DCF_BYTE5),NULL
	STS(adr_DCF_BYTE6),NULL
	STS(adr_DCF_BYTE7),NULL
DCF_BERECHNUNG_FERTIG:
;-------------------------------------------------------------------------------
; DCF-PIN abfragen																
	sbis DCF_PIN,DCF_PIN_NR	; springe, wenn...	
	rjmp DCF_PIN_LOW
	ldi temp1, 255			; PIN HIGH	
	LDS temp,(adr_DCF_PIN_INVERTIERUNG)
	tst temp
	breq DCF_PIN_FERTIG
	dec temp				; -1		
	STS(adr_DCF_PIN_INVERTIERUNG),temp
	rjmp DCF_PIN_FERTIG
DCF_PIN_LOW:
	ldi temp1, 0			; PIN LOW	
	LDS temp,(adr_DCF_PIN_INVERTIERUNG)
	cpi temp,255
	breq DCF_PIN_FERTIG
	inc temp				; +1		
	STS(adr_DCF_PIN_INVERTIERUNG),temp
DCF_PIN_FERTIG:
;-------------------------------------------------------------------------------
; DCF-Trger-Invertierung														
; OUT: temp1 (0=Trger off)														
	LDS temp,(adr_DCF_PIN_INVERTIERUNG)
	cpi temp,127
	brlo DCF_NO_INVERT
	com temp1 				; invertieren !
DCF_NO_INVERT:
	STS(adr_DCF_TRAEGER),temp1
;-------------------------------------------------------------------------------
; DCF-Trger-LED																
	LDS temp,(adr_DCF_GUELTIG)
	tst temp
	brne DCF_LED_OFF
	LDS temp,(adr_DCF_TRAEGER)
	tst temp
	breq DCF_LED_ON
DCF_LED_OFF:
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB	aus	
	rjmp DCF_LED_FERTIG
DCF_LED_ON:
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB	an	
DCF_LED_FERTIG:
;-------------------------------------------------------------------------------
; Phase, den 10ms TIMER auf HIGH-LOW Flanke des DCF-Trgers abgleichen.			
	LDS temp1,(adr_DCF_TRAEGER)		; Trger load		
	LDS temp,(adr_DCF_TRAEGER_OLD)	; OLD load			
	STS(adr_DCF_TRAEGER_OLD),temp1	; OLD save			
	tst temp1						; Trger HIGH ?		
	brne DCF_PHASE_FERTIG			; ja-->Sprung		
	tst temp						; OLD LOW ?			
	breq DCF_PHASE_FERTIG			; ja-->Sprung		
	; HIGH/LOW Flanke erkannt	
	LDS temp,(adr_DCF_10ms)
	STS(adr_DCF_PHASE),temp			; save fr Wartungszwecke
	; im Toleranzbereich ?		
	cpi temp,(0)					; 0
	breq DCF_PHASE_OK
	cpi temp,(1)					; 1
	breq DCF_PHASE_OK
	cpi temp,(99)					; 99
	breq DCF_PHASE_OK
	; Phasenfehler				
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)	; ROT an	
	LDS temp,(adr_DCF_PHASE_TIMER)
	dec temp						; -1				
	STS(adr_DCF_PHASE_TIMER),temp
	; TIMER abgelaufen?			
	tst temp					
	brne DCF_PHASE_FERTIG			; nein-->Sprung		
	LDS temp,(adr_DCF_10ms)	
	cpi temp,50
	brlo DCF_PHASE_w
	LDS temp,(adr_DCF_ss)
	inc temp						; DCFss+1			
	STS(adr_DCF_ss),temp
DCF_PHASE_w:
	STS(adr_DCF_10ms),NULL			; NULL !			
DCF_PHASE_OK:
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)	; ROT aus
	ldi temp,(DCF_PHASE_TIMERWERT)	; TIMERWERT			
	STS(adr_DCF_PHASE_TIMER),temp
DCF_PHASE_FERTIG:
;-------------------------------------------------------------------------------
; SAMPLES(A)(B)																	
	LDS temp,(adr_DCF_10ms)
	cpi temp,(0)
	breq DCF_NULL
	cpi temp,(5)
	breq DCF_SAMPLES_A
	cpi temp,(15)
	breq DCF_SAMPLES_B
	sbi (LED_BLAU_PORT),(LED_BLAU_PIN_NR)	; BLAU	
	ret
;-------------------------------------------------------------------------------
; 																				
DCF_NULL:
	cbi (LED_BLAU_PORT),(LED_BLAU_PIN_NR)	; BLAU	
ret
;-------------------------------------------------------------------------------
; SAMPLES(A)																	
DCF_SAMPLES_A:
	cbi (LED_BLAU_PORT),(LED_BLAU_PIN_NR)	; BLAU	
	LDS temp,(adr_DCF_TRAEGER)
	STS(adr_DCF_SAMPLES_A),temp				; (A)				
	ret
;-------------------------------------------------------------------------------
; SAMPLES(B)																	
; DCF-DATA-HIGH-LOW-IMPULS erkennen.											
; Nur nach Minutenende suchen, wenn DCF ungltig ist.							
DCF_SAMPLES_B:
	cbi (LED_BLAU_PORT),(LED_BLAU_PIN_NR)	; BLAU	
	LDS temp,(adr_DCF_TRAEGER)				; (B)				
	tst temp								; (B)=TRGER off ?	
	breq DCF_BIT_SET						; ja-->Sprung		
	; (A)=(B)=1=TRGER ON= MINUTENENDE ?	
	LDS temp,(adr_DCF_SAMPLES_A)			; (A)				
	tst temp								; (A)=TRGER off ?	
	breq DCF_SAMPLES_B_FERTIG				; ja-->Sprung		
	; MINUTENENDE !							
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB	an	
	LDS temp,(adr_DCF_GUELTIG)				
	tst temp								; DCF-gltig ?		
	brne DCF_SAMPLES_B_FERTIG				; ja-->Sprung		
	ldi temp,(59)		
	STS(adr_DCF_ss),temp					; Minutenende immer bei 59. Sekunde	
DCF_SAMPLES_B_FERTIG:
	ret
;-------------------------------------------------------------------------------
; BIT setzen, nicht clear														
DCF_BIT_SET:
	ldi  ZL, LOW(adr_DCF_BYTE0)	; Z initialiesieren
	ldi  ZH,HIGH(adr_DCF_BYTE0)
	LDS  temp,(adr_DCF_ss)
	LSR  temp					; :2
	LSR  temp					; :4
	LSR  temp					; :8
	add  ZL,temp
	adc  ZH,NULL
	LD   temp1,Z				; SRAM read
	LDS  temp,(adr_DCF_ss)
	andi temp,0b00000111
	cpi  temp,0
	breq DCF_WRITE_BIT_0
	cpi  temp,1
	breq DCF_WRITE_BIT_1
	cpi  temp,2
	breq DCF_WRITE_BIT_2
	cpi  temp,3
	breq DCF_WRITE_BIT_3
	cpi  temp,4
	breq DCF_WRITE_BIT_4
	cpi  temp,5
	breq DCF_WRITE_BIT_5
	cpi  temp,6
	breq DCF_WRITE_BIT_6
	rjmp DCF_WRITE_BIT_7
DCF_WRITE_BIT_0:
	ori temp1,0b00000001; Bitmuster	
	ST Z,temp1			; SRAM write
	ret
DCF_WRITE_BIT_1:
	ori temp1,0b00000010
	ST Z,temp1
	ret
DCF_WRITE_BIT_2:
	ori temp1,0b00000100
	ST Z,temp1
	ret
DCF_WRITE_BIT_3:
	ori temp1,0b00001000
	ST Z,temp1
	ret
DCF_WRITE_BIT_4:
	ori temp1,0b00010000
	ST Z,temp1
	ret
DCF_WRITE_BIT_5:
	ori temp1,0b00100000
	ST Z,temp1
	ret
DCF_WRITE_BIT_6:
	ori temp1,0b01000000
	ST Z,temp1
	ret
DCF_WRITE_BIT_7:
	ori temp1,0b10000000
	ST Z,temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1,2,4,8,10,20,40,80																
; INP: temp																		
; OUT: temp1																	
; 	   temp3 (PARITT)															
DCF_UMRECHNUNG_TEMP1_PARI:
	mov  temp,temp1
	clr  temp1
;-------------------------------------------------------------------------------
	SBRC temp,0
	subi temp1,-1	; +1
	SBRC temp,0
	inc  temp3		; +1 (PARITT)
;-------------------------------------------------------------------------------
	SBRC temp,1
	subi temp1,-2	; +2
	SBRC temp,1
	inc  temp3		; +1 (PARITT)
;-------------------------------------------------------------------------------
	SBRC temp,2
	subi temp1,-4	; +4
	SBRC temp,2
	inc  temp3		; +1 (PARITT)
;-------------------------------------------------------------------------------
	SBRC temp,3
	subi temp1,-8	; +8
	SBRC temp,3
	inc  temp3		; +1 (PARITT)
;-------------------------------------------------------------------------------
	SBRC temp,4
	subi temp1,-10	; +10
	SBRC temp,4
	inc  temp3		; +1 (PARITT)
;-------------------------------------------------------------------------------
	SBRC temp,5
	subi temp1,-20	; +20
	SBRC temp,5
	inc  temp3		; +1 (PARITT)
;-------------------------------------------------------------------------------
	SBRC temp,6
	subi temp1,-40	; +40
	SBRC temp,6
	inc  temp3		; +1 (PARITT)
;-------------------------------------------------------------------------------
	SBRC temp,7
	subi temp1,-80	; +80
	SBRC temp,7
	inc  temp3		; +1 (PARITT)
	andi temp3,0b00000001;PARITT 
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
DCF_BERECHNUNG:
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRUEN aus
	STS(adr_DCF_GUELTIG),NULL
;-------------------------------------------------------------------------------
; (0) Minutenstart immer "0"													
	LDS temp1,(adr_DCF_BYTE0)
	andi temp1,00000001
	; ERROR ?				
	tst temp1
	breq DCF_BERECHNUNG_MINUTENSTART_OK
	ldi temp,(ERROR_DCF_MINUTENSTART)	; CODE
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_BERECHNUNG_MINUTENSTART_OK:
;-------------------------------------------------------------------------------
; (17)(18) MEZ/ MESZ															
	LDS temp1,(adr_DCF_BYTE2)
	LSR temp1	;
	andi temp1,0b00000011
	mov temp,temp1			; KOPIE
	andi temp,0b00000001
	STS(adr_DCF_MESZ),temp
	; ERROR ?				
	cpi temp1,1
	breq DCF_BERECHNUNG_MESZ_OK
	cpi temp1,2
	breq DCF_BERECHNUNG_MESZ_OK
	ldi temp,(ERROR_DCF_MESZ)	; CODE
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_BERECHNUNG_MESZ_OK:
;-------------------------------------------------------------------------------
; (20) Beginn Zeitinformation immer "1"											
	LDS temp1,(adr_DCF_BYTE2)
	andi temp1,0b00010000
	; ERROR ?				
	tst temp1
	brne DCF_BERECHNUNG_ANFANGSBIT_OK
	ldi temp,(ERROR_DCF_NO_ANFANGSBIT)	; CODE
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_BERECHNUNG_ANFANGSBIT_OK:
;-------------------------------------------------------------------------------
; (21-27)MINUTE																	
	clr temp3				; PARITT
	LDS temp1,(adr_DCF_BYTE2)
	LDS temp2,(adr_DCF_BYTE3)
	LSR temp2	;
	ROR temp1
	LSR temp2	;
	ROR temp1
	LSR temp2	;
	ROR temp1
	LSR temp2	;
	ROR temp1
	LSR temp2	;
	ROR temp1
	andi temp1,0b01111111
	rcall DCF_UMRECHNUNG_TEMP1_PARI
	STS(adr_DCF_mm),temp1
	; ERROR ?				
	cpi temp1,(59+1)
	brlo DCF_BERECHNUNG_MINUTE_OK
DCF_BERECHNUNG_MINUTE_ERROR:
	ldi temp,(ERROR_DCF_MINUTE)	; CODE
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_BERECHNUNG_MINUTE_OK:
;-------------------------------------------------------------------------------
; (28) Paritt Minute															
	LDS temp1,(adr_DCF_BYTE3)
	LSR temp1	;
	LSR temp1	;
	LSR temp1	;
	LSR temp1	;
	andi temp1,0b00000001
	cp temp1,temp3
	breq DCF_BERECHNUNG_PARITAET_MINUTE_OK
	ldi temp,(ERROR_DCF_MINUTE_PARITAET)	; CODE
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_BERECHNUNG_PARITAET_MINUTE_OK:
;-------------------------------------------------------------------------------
; (29-34)STUNDE																	
	clr temp3				; PARITT
	LDS temp1,(adr_DCF_BYTE3)
	LDS temp2,(adr_DCF_BYTE4)
	LSR temp2	;
	ROR temp1
	LSR temp2	;
	ROR temp1
	LSR temp2	;
	ROR temp1
	LSR temp2	;
	ROR temp1
	LSR temp2	;
	ROR temp1
	andi temp1,0b00111111
	rcall DCF_UMRECHNUNG_TEMP1_PARI
	STS(adr_DCF_hh),temp1
	; ERROR ?				
	cpi temp1,(23+1)
	brlo DCF_BERECHNUNG_STUNDE_OK
DCF_BERECHNUNG_STUNDE_ERROR:
	ldi temp,(ERROR_DCF_STUNDE)	; CODE
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_BERECHNUNG_STUNDE_OK:
;-------------------------------------------------------------------------------
; (35) Paritt Stunde															
	LDS temp1,(adr_DCF_BYTE4)
	LSR temp1	;
	LSR temp1	;
	LSR temp1	;
	andi temp1,0b00000001
	cp temp1,temp3
	breq DCF_BERECHNUNG_PARITAET_STUNDE_OK
	ldi temp,(ERROR_DCF_STUNDE_PARITAET)	; CODE
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_BERECHNUNG_PARITAET_STUNDE_OK:
;-------------------------------------------------------------------------------
; (36)TAG																		
	clr temp3				; PARITT
	LDS temp1,(adr_DCF_BYTE4)
	LDS temp2,(adr_DCF_BYTE5)
	LSR temp2	;
	ROR temp1
	LSR temp2	;
	ROR temp1
	LSR temp2	;
	ROR temp1
	LSR temp2	;
	ROR temp1
	andi temp1,0b00111111
	rcall DCF_UMRECHNUNG_TEMP1_PARI
	STS(adr_DCF_TAG),temp1
	; ERROR ?			
	cpi temp1,(0)
	breq DCF_BERECHNUNG_TAG_ERROR
	cpi temp1,(31+1)
	brlo DCF_BERECHNUNG_TAG_OK
DCF_BERECHNUNG_TAG_ERROR:
	ldi temp,(ERROR_DCF_JAHR)	; CODE
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_BERECHNUNG_TAG_OK:
;-------------------------------------------------------------------------------
; (42-44) Wochentag																
	LDS temp1,(adr_DCF_BYTE5)
	LSR temp1	;
	LSR temp1	;
	andi temp1,0b00000111
	rcall DCF_UMRECHNUNG_TEMP1_PARI
	STS(adr_DCF_WOCHENTAG),temp1
	; ERROR ?			
	cpi temp1,(0)
	breq DCF_BERECHNUNG_WOCHENTAG_ERROR
	cpi temp1,(7+1)
	brlo DCF_BERECHNUNG_WOCHENTAG_OK
DCF_BERECHNUNG_WOCHENTAG_ERROR:
	ldi temp,(ERROR_DCF_WOCHENTAG)	; CODE
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_BERECHNUNG_WOCHENTAG_OK:
;-------------------------------------------------------------------------------
; (45-49)MONAT																	
	LDS temp1,(adr_DCF_BYTE5)
	LDS temp2,(adr_DCF_BYTE6)
	LSR temp2	;
	ROR temp1
	LSR temp2	;
	ROR temp1
	LSR temp2	;
	ROR temp1
	LSR temp2	;
	ROR temp1
	LSR temp2	;
	ROR temp1
	andi temp1,0b00011111
	rcall DCF_UMRECHNUNG_TEMP1_PARI
	STS(adr_DCF_MONAT),temp1
	; ERROR ?			
	cpi temp1,(0)
	breq DCF_BERECHNUNG_MONAT_ERROR
	cpi temp1,(12+1)
	brlo DCF_BERECHNUNG_MONAT_OK
DCF_BERECHNUNG_MONAT_ERROR:
	ldi temp,(ERROR_DCF_MONAT)	; CODE
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_BERECHNUNG_MONAT_OK:
;-------------------------------------------------------------------------------
; (50-57) JAHR																	
	LDS temp1,(adr_DCF_BYTE6)
	LDS temp2,(adr_DCF_BYTE7)
	LSR temp2	;
	ROR temp1
	LSR temp2	;
	ROR temp1
	rcall DCF_UMRECHNUNG_TEMP1_PARI
	STS(adr_DCF_JAHR),temp1
	; ERROR ?			
	cpi temp1,(99+1)
	brlo DCF_BERECHNUNG_JAHR_OK
DCF_BERECHNUNG_JAHR_ERROR:
	ldi temp,(ERROR_DCF_JAHR)	; CODE
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_BERECHNUNG_JAHR_OK:
;-------------------------------------------------------------------------------
; (58) PARITT																	
	LDS temp1,(adr_DCF_BYTE7)
	LSR temp1	;
	LSR temp1	;
	andi temp1,0b00000001
	; ERROR ?			
	cp  temp1,temp3
	breq DCF_BERECHNUNG_PARITAET_DATUM_OK
	ldi temp,(ERROR_DCF_DATUM_PARITAET)	; CODE
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_BERECHNUNG_PARITAET_DATUM_OK:
;-------------------------------------------------------------------------------
; Zustzlicher Check Datum+Zeit, um Fehler zu minimieren						
	LDS temp,(adr_DCF_TURBO_OFF)	; Turbo on ?	
	tst temp		
	breq DCF_CHECK_FERTIG			; ja--->Sprung	

	LDS temp1,(adr_DCF_mm)			; mm			
	LDS temp2,(adr_DCF_mm_OLD)
	inc temp2						; OLD+1			
	cpi temp2,(59+1)
	brlo DCF_CHECK_MM_w
	ldi temp2,(0)
DCF_CHECK_MM_w:
	cp temp1,temp2
	brne DCF_CHECK_ERROR

	; Minute = "00"					
	LDS temp,(adr_DCF_mm)
	tst temp			
	breq DCF_CHECK_FERTIG			; ja--->Sprung	

	LDS temp1,(adr_DCF_hh)			; hh		
	LDS temp2,(adr_DCF_hh_OLD)
	cp temp1,temp2
	brne DCF_CHECK_ERROR

	LDS temp1,(adr_DCF_TAG)			; TAG		
	LDS temp2,(adr_DCF_TAG_OLD)
	cp temp1,temp2
	brne DCF_CHECK_ERROR

	LDS temp1,(adr_DCF_WOCHENTAG)	; WOCHENTAG	
	LDS temp2,(adr_DCF_WOCHENTAG_OLD)
	cp temp1,temp2
	brne DCF_CHECK_ERROR

	LDS temp1,(adr_DCF_MONAT)		; MONAT		
	LDS temp2,(adr_DCF_MONAT_OLD)
	cp temp1,temp2
	brne DCF_CHECK_ERROR

	LDS temp1,(adr_DCF_JAHR)		; JAHR		
	LDS temp2,(adr_DCF_JAHR_OLD)
	cp temp1,temp2
	brne DCF_CHECK_ERROR

	LDS temp1,(adr_DCF_MESZ)		; MESZ		
	LDS temp2,(adr_DCF_MESZ_OLD)
	cp temp1,temp2
	brne DCF_CHECK_ERROR

	rjmp DCF_CHECK_FERTIG
;-------------------------------------------------------------------------------
DCF_CHECK_ERROR:
	ldi temp,(ERROR_DCF_VERGLEICH)	; CODE		
	STS(adr_DCF_ERROR_CODE),temp
	rcall DCF_KOPIE_OLD				; KOPIE		
	ret
DCF_CHECK_FERTIG:
;-------------------------------------------------------------------------------
; Alles koorekt, Quarz-Uhr stellen												
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRUEN an
	rcall DCF_KOPIE_OLD				; KOPIE		
	STS(adr_DCF_ERROR_CODE),NULL
	STS(adr_DCF_GUELTIG),EINS
	STS(adr_DCF_TURBO_OFF),EINS
	; Quarz-Uhr stellen			
	STS(adr_10ms),NULL
	STS(adr_ss),NULL
	LDS temp,(adr_DCF_mm)
	STS(adr_mm),temp
	LDS temp,(adr_DCF_hh)
	STS(adr_hh),temp
	LDS temp,(adr_DCF_WOCHENTAG)
	STS(adr_WOCHENTAG),temp
	LDS temp,(adr_DCF_TAG)
	STS(adr_TAG),temp
	LDS temp,(adr_DCF_MONAT)
	STS(adr_MONAT),temp
	LDS temp,(adr_DCF_JAHR)
	STS(adr_JAHR),temp
	LDS temp,(adr_DCF_MESZ)
	STS(adr_MESZ),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DCF_KOPIE_OLD:
	LDS temp,(adr_DCF_mm)		; mm	
	STS(adr_DCF_mm_OLD),temp

	LDS temp,(adr_DCF_hh)		; hh	
	STS(adr_DCF_hh_OLD),temp

	LDS temp,(adr_DCF_TAG)		; TAG	
	STS(adr_DCF_TAG_OLD),temp

	LDS temp,(adr_DCF_WOCHENTAG); Wochentag
	STS(adr_DCF_WOCHENTAG_OLD),temp

	LDS temp,(adr_DCF_MONAT)	; Monat	
	STS(adr_DCF_MONAT_OLD),temp

	LDS temp,(adr_DCF_JAHR)		; Jahr	
	STS(adr_DCF_JAHR_OLD),temp

	LDS temp,(adr_DCF_MESZ)		; MESZ	
	STS(adr_DCF_MESZ_OLD),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################



























