; ##############################################################################
; ##############################################################################
; ##############################################################################
Watchdog_aktivieren:
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
NEUSTART_MIT_WDR:
	WDR
	in temp, MCUCSR
	andi temp,0b00001000
	tst temp
	breq NEUSTART_MIT_WDR_FEHLER
	; MCUCSR clear		
	out MCUCSR,NULL
	ret
NEUSTART_MIT_WDR_FEHLER:
	rjmp NEUSTART_MIT_WDR_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (SRAM_START)
	ldi ZH, HIGH(SRAM_START)
	ldi temp,0
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PORT B+C+D CLEAR																
PORT_CLEAR:
	ldi temp, 0b00000000	
	out DDRB, temp
	out DDRC, temp
	out DDRD, temp
	out PORTB,temp				
	out PORTC,temp				
	out PORTD,temp	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; DDR (EINGANG) abfragen			
	sbic  (DCF_DDR) ,(DCF_PIN_NR) 						; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER	
	; DDR (AUSGANG) LED abfragen		
	sbis  (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR) 	; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (LED_GELB_DDR),(LED_GELB_PIN_NR) 		; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (LED_ROT_DDR),(LED_ROT_PIN_NR) 		; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (LED_BLAU_DDR),(LED_BLAU_PIN_NR) 		; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	; DDR (AUSGANG) DIG abfragen		
	sbis  (PORT_DDR_DIG_0),(PIN_DIG_0) 					; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_DIG_1),(PIN_DIG_1) 					; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_DIG_2),(PIN_DIG_2) 					; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_DIG_3),(PIN_DIG_3) 					; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_DIG_4),(PIN_DIG_4) 					; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_DIG_5),(PIN_DIG_5) 					; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	; DDR (AUSGANG) BALKEN abfragen		
	sbis  (PORT_DDR_BALKEN_A),(PIN_BALKEN_A) 			; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_BALKEN_B),(PIN_BALKEN_B) 			; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_BALKEN_C),(PIN_BALKEN_C) 			; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_BALKEN_D),(PIN_BALKEN_D) 			; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_BALKEN_E),(PIN_BALKEN_E) 			; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_BALKEN_F),(PIN_BALKEN_F) 			; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_BALKEN_G),(PIN_BALKEN_G) 			; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER
	sbis  (PORT_DDR_BALKEN_P),(PIN_BALKEN_P) 			; springe, wenn...
	rjmp PROGRAMM_CHECK_FEHLER

	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; SRAM		
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER	
	ret
;-------------------------------------------------------------------------------
; Neustart !!																	
PROGRAMM_CHECK_FEHLER:
	CLI	; iNTERRUPT SPERREN
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRUEN aus	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus	
	rcall wait_100ms
	rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_INITIALISIERUNG:
	; auf AUSGANG	
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)	; GRUEN		
	sbi (LED_GELB_DDR),(LED_GELB_PIN_NR)  	; GELB		
	sbi (LED_ROT_DDR),(LED_ROT_PIN_NR)		; ROT		
	sbi (LED_BLAU_DDR),(LED_BLAU_PIN_NR)	; BLAU		
	sbi (RELAIS_DDR),(RELAIS_PIN_NR)		; RELAIS	
	; LEDs an		
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRUEN		
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB		
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)		; ROT		
	cbi (LED_BLAU_PORT),(LED_BLAU_PIN_NR)	; BLAU		
	sbi (RELAIS_PORT),(RELAIS_PIN_NR)		; RELAIS aus
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_TEST:
	; AUS			
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRUEN		
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB		
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)	 	; ROT		
	sbi (LED_BLAU_PORT),(LED_BLAU_PIN_NR)	; BLAU		
	; AN			
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRUEN		
	rcall wait_100ms
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB		
	rcall wait_100ms
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)	 	; ROT		
	rcall wait_100ms
	cbi (LED_BLAU_PORT),(LED_BLAU_PIN_NR)	; BLAU		
	rcall wait_100ms
	; AUS			
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRUEN		
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB		
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)	 	; ROT		
	sbi (LED_BLAU_PORT),(LED_BLAU_PIN_NR)	; BLAU		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_RELAIS_KLICK:
	LDS temp,(adr_mm)
	tst temp
	breq BERECHNUNG_RELAIS_KLICK_w1
	ret
BERECHNUNG_RELAIS_KLICK_w1:
	LDS temp,(adr_ss)
	tst temp
	breq BERECHNUNG_RELAIS_KLICK_w2
	ret
BERECHNUNG_RELAIS_KLICK_w2:
	rcall RELAIS_KLICK
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
RELAIS_KLICK:
	cbi (RELAIS_PORT),(RELAIS_PIN_NR)				; RELAIS	
	rcall wait_100ms
	sbi (RELAIS_PORT),(RELAIS_PIN_NR)				; RELAIS	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

