; DCF77-MODUL (Samlingverfahren)				
; Bernhard.Erfurt@gmx.de						
; 09/2016										
;												
; 16 MHz										
; 6 x 7 Segment									
;												


; LED GRUEN: DCF ok								
; LED GELB: DCF-Impuls bzw. Minutenerkennung	
; LED ROT: Phasenkorrektur						

; LED ROT blinkt: Programm Check Error			
; LED ROT+GELB blinkt: Interrupt Error			
; LED ROT+GELB+GRN blinkt: WDR Error (nicht in dieser Version)	

; Anschlussbelegung PINS						
;												
; PB0 ==> (s.Anschlussbelegung)					
; PB1 ==> (s.Anschlussbelegung)					
; PB2 ==> (s.Anschlussbelegung)					
; PB3 ==> (s.Anschlussbelegung)					
; PB4 ==> (s.Anschlussbelegung)					
; PB5 ==> (s.Anschlussbelegung)					
; PB6 ==> Quarz	16MHz							
; PB7 ==> Quarz	16MHz							
;												
; PC0 ==> LED BLAU (DCF TESTAUSGANG)			
; PC1 ==> RELAIS (STUNDEN-KLICK)				
; PC2 ==> DCF-EINGANG							
; PC3 ==> LED-GRN								
; PC4 ==> LED-GELB								
; PC5 ==> LED-ROT 								
;												
; PD0 ==> (A-s.Anschlussbelegung)				
; PD1 ==> (B-s.Anschlussbelegung)				
; PD2 ==> (C-s.Anschlussbelegung)				
; PD3 ==> (D-s.Anschlussbelegung)				
; PD4 ==> (E-s.Anschlussbelegung)				
; PD5 ==> (F-s.Anschlussbelegung)				
; PD6 ==> (G-s.Anschlussbelegung)				
; PD7 ==> (P-s.Anschlussbelegung)				
;												


; ATmega8 										
.include "m8def.inc"
; TIMER-WERTE									
.equ TIMERWERT1						=65536-250	;(2 hoch 16 minus....) bei 16MHz  => 0,001s=1ms 			
; Nachtruhe										
.equ NACHTRUHE_BEGINN				= 22	; 22 Uhr
.equ NACHTRUHE_ENDE					= 6		; 06 Uhr
.equ HELLIGKEIT_TAG					= 6
.equ HELLIGKEIT_NACHT				= 25
; DCF-EINGANG									
.equ DCF_PIN_NR						= 2
.equ DCF_DDR						= DDRC
.equ DCF_PORT						= PORTC
.equ DCF_PIN						= PINC
; RELAIS										
.equ RELAIS_PIN_NR					= 1
.equ RELAIS_DDR						= DDRC
.equ RELAIS_PORT					= PORTC
; LED-GRUEN									
.equ LED_GRUEN_PIN_NR				= 3
.equ LED_GRUEN_DDR					= DDRC
.equ LED_GRUEN_PORT					= PORTC
; LED-GELB									
.equ LED_GELB_PIN_NR				= 4
.equ LED_GELB_DDR					= DDRC
.equ LED_GELB_PORT					= PORTC
; LED-ROT									
.equ LED_ROT_PIN_NR					= 5
.equ LED_ROT_DDR					= DDRC
.equ LED_ROT_PORT					= PORTC
; LED-BLAU									
.equ LED_BLAU_PIN_NR				= 0
.equ LED_BLAU_DDR					= DDRC
.equ LED_BLAU_PORT					= PORTC





; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					= SRAM_START		; 0x0060 START Adresse 						
.equ adr_FREIGABE_PROGRAMM		= SRAM_START+0		; fr Anzeige		

.equ adr_LED_HELLIGKEITSWERT	= SRAM_START+10		; HELLIGKEIT (6...40)
.equ adr_LED_DIGIT_ZAEHLER		= SRAM_START+11		; interner Zhler	
.equ adr_LED_BYTE_0				= SRAM_START+12		; DIGIT				
.equ adr_LED_BYTE_1				= SRAM_START+13		; DIGIT				
.equ adr_LED_BYTE_2				= SRAM_START+14		; DIGIT				
.equ adr_LED_BYTE_3				= SRAM_START+15		; DIGIT				
.equ adr_LED_BYTE_4				= SRAM_START+16		; DIGIT				
.equ adr_LED_BYTE_5				= SRAM_START+17		; DIGIT				

.equ adr_ssVT					= SRAM_START+20		; Vorteiler			
.equ adr_10ms					= SRAM_START+21		; 10ms				
.equ adr_ss						= SRAM_START+22		; Sekunden			
.equ adr_mm						= SRAM_START+23		; Minuten			
.equ adr_hh						= SRAM_START+24		; Stunden			
.equ adr_TAG					= SRAM_START+25		; Tag				
.equ adr_WOCHENTAG				= SRAM_START+26		; WochenTag			
.equ adr_MONAT					= SRAM_START+27		; Monat				
.equ adr_JAHR					= SRAM_START+28		; Jahr				
.equ adr_MESZ					= SRAM_START+29		; MESZ				

.equ adr_DCF_BEREICH			= SRAM_START+50	 	; 33 BYTES fr DCF	

.equ adr_SRAM_CHECK				= SRAM_START+900	; Programm-Check	

; REGISTER										
.def NULL 	= R14
.def EINS 	= R15
.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   		; IRQ0 Handler                  
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp TIM1_OVF  			; Timer1 Overflow Handler           					
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR 	; USART RX Complete Handler         					
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Interrupt-ERROR ==> NEUSTART						
INTERRUPT_ERROR:
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRUEN	aus 
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus  
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR
RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM CLEAR										
	rcall SRAM_CLEAR
; PORT CLEAR										
	rcall PORT_CLEAR
; LED_INITIALISIERUNG								
	rcall LED_INITIALISIERUNG
; LED_7SEGMENT_INITIALISIERUNG						
	rcall LED_7SEGMENT_INITIALISIERUNG
; Watchdog aktivieren (max. Zeit)					
	rcall Watchdog_aktivieren
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; LED_TEST											
	rcall LED_TEST
; TIMER1_INITIALISIERUNG							
	rcall TIMER1_INITIALISIERUNG
; TIMER aktivieren									
	rcall TIMER_AKTIVIEREN
; Startwerte										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; ZEIT hh			
	ldi temp,0
	STS(adr_hh),temp
	; ZEIT mm			
	ldi temp,0
	STS(adr_mm),temp
	; ZEIT ss			
	ldi temp,0
	STS(adr_ss),temp
	; DATUM				
	ldi temp,1
	STS(adr_TAG),temp
	ldi temp,1
	STS(adr_MONAT),temp
	ldi temp,1
	STS(adr_JAHR),temp
	ldi temp,7
	STS(adr_WOCHENTAG),temp
	; SRAM-CHECK				
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	; HELLIGKEIT (6...ca.30)	
	ldi temp,(HELLIGKEIT_TAG)
	STS(adr_LED_HELLIGKEITSWERT),temp
; DCF_INITIALISIERUNG								
	rcall DCF_INITIALISIERUNG
; PROGRAMM_CHECK									
	rcall PROGRAMM_CHECK
; interrupts freigeben								
	sei

	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRUEN		
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB		
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)	 	; ROT		
	sbi (LED_BLAU_PORT),(LED_BLAU_PIN_NR)	; BLAU		
	rcall RELAIS_KLICK						; RELAIS-KLICK				

; LED_7SEGMENT_TEST									
	rcall LED_VERSION_ANZEIGEN
	rcall wait_1s
	rcall wait_1s
	rcall LED_7SEGMENT_TEST_A
	rcall LED_7SEGMENT_TEST_B
	rcall LED_7SEGMENT_TEST_C
	rcall wait_1s
	rcall LED_ALLE_AUS
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR
	LDS temp,(adr_FREIGABE_PROGRAMM)
	tst temp 
	breq LOOP
;-------------------------------------------------------------------------------
	STS(adr_FREIGABE_PROGRAMM),NULL
	rcall MENUE
	rcall PROGRAMM_CHECK
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	; Strunterdrckung 3 Uhr alles aus	
	LDS temp,(adr_DCF_GUELTIG)
	tst temp			; gltig ?		
	brne MENUE_RUN		; ja --> Sprung	
	LDS temp,(adr_hh)	
	cpi temp,3			; 3 Uhr ?		
	brne MENUE_RUN		; nein -->Sprung
	rcall LED_ALLE_AUS
	ret
;-------------------------------------------------------------------------------
MENUE_RUN:
	LDS temp,(adr_ss)
	cpi temp,30
	breq MENUE_ANZEIGE_DATUM
	cpi temp,31
	breq MENUE_ANZEIGE_DATUM
	rcall BERECHNUNG_HELLIGKEIT
	rcall LED_ZEIT_ANZEIGEN
	rcall BERECHNUNG_RELAIS_KLICK
	ret
MENUE_ANZEIGE_DATUM:
	rcall BERECHNUNG_HELLIGKEIT
	rcall LED_DATUM_ANZEIGEN
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Nachtruhe ?																	
BERECHNUNG_HELLIGKEIT:
	LDS temp,(adr_hh)
	cpi temp,(NACHTRUHE_ENDE)
	brlo BERECHNUNG_HELLIGKEIT_DUNKEL
	cpi temp,(NACHTRUHE_BEGINN)
	brsh BERECHNUNG_HELLIGKEIT_DUNKEL
BERECHNUNG_HELLIGKEIT_HELL:
	ldi temp,(HELLIGKEIT_TAG)
	STS(adr_LED_HELLIGKEITSWERT),temp
	ret
BERECHNUNG_HELLIGKEIT_DUNKEL:
	ldi temp,(HELLIGKEIT_NACHT)
	STS(adr_LED_HELLIGKEITSWERT),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "DCF_TIMER.asm"
.include "DCF_DCF.asm"
.include "DCF_LED.asm"
.include "DCF_LED_BELEGUNG6.asm"
.include "DCF_SONSTIGES.asm"
.include "DCF_WAIT_16MHZ.asm"







